Texture3D txObject;
Texture1D txTransfer;

SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
    AddressW = Clamp;
};

float w;

struct PS_INPUT
{
    float4 Pos : SV_POSITION;
    float3 Tex : TEXCOORD0;
};

PS_INPUT VS(float4 pos : POSITION)
{
    PS_INPUT output;
    output.Pos = pos;
    output.Tex = pos / 2 + 0.5;  // Convert [-1 1] to [0 1]
    return output;
}

float4 PS(PS_INPUT input) : SV_Target
{
	  float val = txObject.Sample(samLinear, float3(w, input.Tex.x, input.Tex.y)) / 4096;
    float3 color = txTransfer.Sample(samLinear, val);
    return float4(color, 1.0f);
}


technique10 Render
{
    pass P0
    {
        SetVertexShader(CompileShader(vs_4_0, VS()));
        SetGeometryShader(NULL);
        SetPixelShader(CompileShader(ps_4_0, PS()));
    }
}